import pytest
from datetime import datetime

from aircox import utils


class TestSchedule:
    @pytest.mark.django_db
    def test_save_rerun(self, sched_reruns):
        for schedule in sched_reruns:
            schedule.duration = None
            schedule.frequency = None
            schedule.save_rerun()
            assert schedule.program == schedule.initial.program
            assert schedule.duration == schedule.initial.duration
            assert schedule.frequency == schedule.initial.frequency

    @pytest.mark.django_db
    def test_tz(self, schedules):
        for schedule in schedules:
            assert schedule.timezone == schedule.tz.zone

    @pytest.mark.django_db
    def test_start(self, schedules):
        for schedule in schedules:
            assert schedule.start.date() == schedule.date
            assert schedule.start.time() == schedule.time

    @pytest.mark.django_db
    def test_end(self, schedules):
        for schedule in schedules:
            delta = utils.to_timedelta(schedule.duration)
            assert schedule.end - schedule.start == delta

    # def test_get_frequency_verbose(self):
    #    pass

    @pytest.mark.django_db
    def test_normalize(self, schedules):
        for schedule in schedules:
            dt = datetime.combine(schedule.date, schedule.time)
            assert schedule.normalize(dt).tzinfo.zone == schedule.timezone.zone

    @pytest.mark.django_db
    def test_dates_of_month_ponctual(self):
        pass

    @pytest.mark.django_db
    def test_dates_of_month_n_day_of_month(self):
        pass

    @pytest.mark.django_db
    def test_dates_of_month_first_and_third(self):
        pass

    @pytest.mark.django_db
    def test_dates_of_month_second_and_fourth(self):
        pass

    @pytest.mark.django_db
    def test_dates_of_month_every(self):
        pass

    @pytest.mark.django_db
    def test_dates_of_month_one_on_two(self):
        pass

    @pytest.mark.django_db
    def test__exclude_existing_date(self):
        pass

    @pytest.mark.django_db
    def test_diffusions_of_month(self):
        pass
